Package org.apache.commons.net.bsd

# Class RExecClient

java.lang.Object
org.apache.commons.net.SocketClient
org.apache.commons.net.bsd.RExecClient

Direct Known Subclasses:
  `RCommandClient`

public class RExecClient extends SocketClient
RExecClient implements the rexec() facility that first appeared in 4.2BSD Unix. This class will probably only be of use for connecting to Unix systems and only when the rexecd daemon is configured to run, which is a rarity these days because of the security risks involved. However, rexec() can be very useful for performing administrative tasks on a network behind a firewall.

As with virtually all the client classes in org.apache.commons.net, this class derives from SocketClient, inheriting its connection methods. The way to use RExecClient is to first connect to the server, call the `rexec()` method, and then fetch the connection's input, output, and optionally error streams. Interaction with the remote command is controlled entirely through the I/O streams. Once you have finished processing the streams, you should invoke `disconnect()` to clean up properly.

By default, the standard output and standard error streams of the remote process are transmitted over the same connection, readable from the input stream returned by `getInputStream()`. However, it is possible to tell the rexecd daemon to return the standard error stream over a separate connection, readable from the input stream returned by `getErrorStream()`. You can specify that a separate connection should be created for standard error by setting the boolean `separateErrorStream` parameter of `rexec()` to `true`. The standard input of the remote process can be written to through the output stream returned by `getOutputSream()`.

See Also:
  - `SocketClient`
  - `RCommandClient`
  - `RLoginClient`

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `protected InputStream`
  `_errorStream_`
  If a separate error stream is requested, `_errorStream_` will point to an InputStream from which the standard error of the remote process can be read (after a call to rexec()).
  `static final int`
  `DEFAULT_PORT`
  The default rexec port.
  `protected static final char`
  `NULL_CHAR`
  The `NUL` character.

  ### Fields inherited from class org.apache.commons.net.SocketClient

  `_defaultPort_, _hostname_, _input_, _output_, _serverSocketFactory_, _socket_, _socketFactory_, _timeout_, connectTimeout, NETASCII_EOL, remoteInetSocketAddress`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `RExecClient()`
  The default RExecClient constructor.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `disconnect()`
  Disconnects from the server, closing all associated open sockets and streams.
  `InputStream`
  `getErrorStream()`
  Gets the InputStream from which the standard error of the remote process can be read if a separate error stream is requested from the server.
  `InputStream`
  `getInputStream()`
  Gets the InputStream from which the standard output of the remote process can be read.
  `OutputStream`
  `getOutputStream()`
  Gets the OutputStream through which the standard input of the remote process can be written.
  `final boolean`
  `isRemoteVerificationEnabled()`
  Tests whether or not verification of the remote host providing a separate error stream is enabled.
  `void`
  `rexec(String user, String password, String command)`
  Same as `rexec(user, password, command, false);`
  `void`
  `rexec(String user, String password, String command, boolean separateErrorStream)`
  Remotely executes a command through the rexecd daemon on the server to which the RExecClient is connected.
  `final void`
  `setRemoteVerificationEnabled(boolean enable)`
  Sets verification for the remote host connecting to create a separate error stream is the same as the host to which the standard out stream is connected.

  ### Methods inherited from class org.apache.commons.net.SocketClient

  `_connectAction_, addProtocolCommandListener, applySocketAttributes, checkOpenOutputStream, connect, connect, connect, connect, connect, connect, createCommandSupport, fireCommandSent, fireReplyReceived, getCharset, getCharsetName, getCommandSupport, getConnectTimeout, getDefaultPort, getDefaultTimeout, getHostAddress, getHostAddress, getKeepAlive, getLocalAddress, getLocalPort, getProxy, getReceiveBufferSize, getRemoteAddress, getRemoteInetSocketAddress, getRemotePort, getSendBufferSize, getServerSocketFactory, getSoLinger, getSoTimeout, getTcpNoDelay, isAvailable, isConnected, removeProtocolCommandListener, setCharset, setConnectTimeout, setDefaultPort, setDefaultTimeout, setKeepAlive, setProxy, setReceiveBufferSize, setSendBufferSize, setServerSocketFactory, setSocketFactory, setSoLinger, setSoTimeout, setTcpNoDelay, verifyRemote`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Field Details

  - ### NULL_CHAR

    protected static final char NULL_CHAR
    The `NUL` character.
    Since:
      3.3
    See Also:
      - Constant Field Values

  - ### DEFAULT_PORT

    public static final int DEFAULT_PORT
    The default rexec port. Set to 512 in BSD Unix.
    See Also:
      - Constant Field Values

  - ### _errorStream_

    protected InputStream _errorStream_
    If a separate error stream is requested, `_errorStream_` will point to an InputStream from which the standard error of the remote process can be read (after a call to rexec()). Otherwise, `_errorStream_` will be null.

- ## Constructor Details

  - ### RExecClient

    public RExecClient()
    The default RExecClient constructor. Initializes the default port to `DEFAULT_PORT`.

- ## Method Details

  - ### disconnect

    public void disconnect() throws IOException
    Disconnects from the server, closing all associated open sockets and streams.
    Overrides:
      `disconnect` in class `SocketClient`
    Throws:
      `IOException` - If an error occurs while disconnecting.

  - ### getErrorStream

    public InputStream getErrorStream()
    Gets the InputStream from which the standard error of the remote process can be read if a separate error stream is requested from the server. Otherwise, null will be returned. The error stream will only be set after a successful rexec() invocation.
    Returns:
      The InputStream from which the standard error of the remote process can be read if a separate error stream is requested from the server. Otherwise, null will be returned.

  - ### getInputStream

    public InputStream getInputStream()
    Gets the InputStream from which the standard output of the remote process can be read. The input stream will only be set after a successful rexec() invocation.
    Returns:
      The InputStream from which the standard output of the remote process can be read.

  - ### getOutputStream

    public OutputStream getOutputStream()
    Gets the OutputStream through which the standard input of the remote process can be written. The output stream will only be set after a successful rexec() invocation.
    Returns:
      The OutputStream through which the standard input of the remote process can be written.

  - ### isRemoteVerificationEnabled

    public final boolean isRemoteVerificationEnabled()
    Tests whether or not verification of the remote host providing a separate error stream is enabled. The default behavior is for verification to be enabled.
    Returns:
      True if verification is enabled, false if not.

  - ### rexec

    public void rexec(String user, String password, String command) throws IOException
    Same as `rexec(user, password, command, false);`
    Parameters:
      `user` - the user name
      `password` - the password
      `command` - the command to run
    Throws:
      `IOException` - if an error occurs

  - ### rexec

    public void rexec(String user, String password, String command, boolean separateErrorStream) throws IOException
    Remotely executes a command through the rexecd daemon on the server to which the RExecClient is connected. After calling this method, you may interact with the remote process through its standard input, output, and error streams. You will typically be able to detect the termination of the remote process after reaching end of file on its standard output (accessible through `getInputStream()`). Disconnecting from the server or closing the process streams before reaching end of file will not necessarily terminate the remote process.

    If a separate error stream is requested, the remote server will connect to a local socket opened by RExecClient, providing an independent stream through which standard error will be transmitted. RExecClient will do a simple security check when it accepts a connection for this error stream. If the connection does not originate from the remote server, an IOException will be thrown. This serves as a simple protection against possible hijacking of the error stream by an attacker monitoring the rexec() negotiation. You may disable this behavior with `setRemoteVerificationEnabled()`.

    Parameters:
      `user` - The account name on the server through which to execute the command.
      `password` - The plain text password of the user account.
      `command` - The command, including any arguments, to execute.
      `separateErrorStream` - True if you would like the standard error to be transmitted through a different stream than standard output. False if not.
    Throws:
      `IOException` - If the rexec() attempt fails. The exception will contain a message indicating the nature of the failure.

  - ### setRemoteVerificationEnabled

    public final void setRemoteVerificationEnabled(boolean enable)
    Sets verification for the remote host connecting to create a separate error stream is the same as the host to which the standard out stream is connected. The default is for verification to be enabled. You may set this value at any time, whether the client is currently connected or not.
    Parameters:
      `enable` - True to enable verification, false to disable verification.